/*
 * Alarma.c
 *
 * Created: 05/20/18 06:46:47 PM
 * Author : georgiana.besea
 */ 


#define F_CPU 8000000UL	// FCPU Definition for util/delay
#include <avr/io.h>
#include <util/delay.h>
#include "lcd.h"



#define greenLed	PC0
#define redLed		PC1
#define buzzer		PC2

#define sensor	PD0
#define button2	PD1
#define button1 PD2

int index = 0;
int detect = 0;
int compare = 0;
char password[4];
char enter[4];
void keypad();

void detectMove(){
	while(1) {
		
		/* Daca senzorul de miscare se activeaza, declansam alarma*/
		if((PIND & (1<<sensor)) != 0) {
				PORTC &= ~(1 << greenLed);
				PORTC ^= (1 << redLed);
				PORTC ^= (1 << buzzer);
				
				//Asteptam introducerea parolei
				LCD_writeInstr(LCD_INSTR_clearDisplay);
				LCD_print("Password:");
				LCD_writeInstr(LCD_INSTR_nextLine);
				keypad();
		}else{
			PORTC |= (1 << greenLed);
			PORTC |= (1 << sensor);
			PORTC |= (1 << buzzer);
			PORTC &= ~(1 << redLed);
		}
		
	}
}

/*Citim caracterele de pe keypad*/
void keypad()
{
	index = 0;
	while(1){
		
		//First column
		PORTA =0b11101111;
		if (!bit_is_set(PINA, 1)){
			while (!bit_is_set(PINA, 1));
		}
		
		if (!bit_is_set(PINA, 1)){
			while (!bit_is_set(PINA, 1));
			enter[index] == '4';
			index++;
			LCD_print("4");
		}
		if (!bit_is_set(PINA, 2)){
			while (!bit_is_set(PINA, 2));
			enter[index] == '7';
			index++;
			LCD_print("7");
		}
		if (!bit_is_set(PINA, 3)){
			while (!bit_is_set(PINA, 3));
			LCD_print("*");
		}
		
		//Second column
		PORTA =0b11011111;
		if (!bit_is_set(PINA, 0)){
			while (!bit_is_set(PINA, 0));
			enter[index] == '1';
			index++;
			LCD_print("1");
		}
		if (!bit_is_set(PINA, 1)){
			while (!bit_is_set(PINA, 1));
			enter[index] == '5';
			index++;
			LCD_print("5");
		}
		if (!bit_is_set(PINA, 2)){
			while (!bit_is_set(PINA, 2));
			enter[index] == '8';
			index++;
			LCD_print("8");
		}
		if (!bit_is_set(PINA, 3)){
			while (!bit_is_set(PINA, 3));
			enter[index] == '0';
			index++;
			LCD_print("0");
		}
		
		//Third column
		PORTA =0b10111111;
		if (!bit_is_set(PINA, 0)){
			while (!bit_is_set(PINA, 0));
			enter[index] == '2';
			index++;
			LCD_print("2");
		}
		if (!bit_is_set(PINA, 1)){
			while (!bit_is_set(PINA, 1));
			enter[index] == '6';
			index++;
			LCD_print("6");
		}
		if (!bit_is_set(PINA, 2)){
			while (!bit_is_set(PINA, 2));
			enter[index] == '9';
			index++;
			LCD_print("9");
		}
		if (!bit_is_set(PINA, 3)){
			while (!bit_is_set(PINA, 3));
			LCD_print("#");
		}
		
		//Fourth column
		PORTA =0b01111111;
		if (!bit_is_set(PINA, 0)){
			while (!bit_is_set(PINA, 0));
			enter[index] == '3';
			index++;
			LCD_print("3");
		}
		if (!bit_is_set(PINA, 2)){
			while (!bit_is_set(PINA, 2));
		}
		if (!bit_is_set(PINA, 3)){
			while (!bit_is_set(PINA, 3));
			LCD_print("D");
		}
		
		//ENTER -"B"
		PORTA =0b01111111;
		if (!bit_is_set(PINA, 1)){
			while (!bit_is_set(PINA, 1));
			if (index == 4) {
				index = 0;
				compare = 1;
				for(int i = 0; i < 4; i++) {
					if(enter[i] == password[i]){
						compare = 0;
					}
				}
				if(compare == 1) {
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("  Alarm is on  ");
					PORTC ^= (1 << greenLed);
					PORTC |= (1 << sensor);
					PORTC |= (1 << buzzer);
					PORTC &= ~(1 << redLed);
				}else if (compare == 0) {
					
					PORTC &= ~(1 << greenLed);
					PORTC ^= (1 << redLed);
					PORTC |= (1 << buzzer);
				}
				break;
			}
		}
		
		//Activare alarma- "A"
		PORTA =0b01111111;
		if (!bit_is_set(PINA, 0)){
			while (!bit_is_set(PINA, 0));
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_print("  ALARM IS ON  ");
			LCD_writeInstr(LCD_INSTR_nextLine);
			detectMove();
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_print("  ALARM IS OFF  ");
			LCD_writeInstr(LCD_INSTR_nextLine);
			LCD_print("Press A-activate");
		}
		
		//Backspace- "C"
		PORTA =0b01111111;
		if (!bit_is_set(PINA, 2)){
			while (!bit_is_set(PINA, 2));
				if (index>0){
					index = 0;
					LCD_writeInstr(LCD_INSTR_clearDisplay);
					LCD_print("Password:  ");
					LCD_writeInstr(LCD_INSTR_nextLine);
				}
		}
	}

}

int main(void)
{

	DDRA = 0xF0;		//setam PA4 PA5 PA6 PA7 ca fiind de output si PA0 PA1 PA2 PA3 de input
	PORTA = 0x0F; 		//setam rezistenta de pullup pe PA0 PA1 PA2 PA3
	
	DDRC |= (1 << greenLed);
	DDRC |= (1 << redLed);
	
	DDRD &= ~(1 << sensor); /* Setez pinul PD0 ca intrare. */
	PORTD |= (1 << sensor);	/* Activez rezistenta de pull-up pentru senzor. */
	
	DDRD &= ~(1 << button2);	/* Setez pinul PD1 ca intrare. */
	PORTD |= (1 << button2);	/* Activez rezistenta de pull-up pentru pinul PD1. */


	/*Initializam ecran LCD*/
	LCD_init();
	LCD_print(" SECURITY ALARM ");
	_delay_ms(10000);

	LCD_writeInstr(LCD_INSTR_clearDisplay);
	LCD_print("  ALARM IS OFF  ");	
	LCD_writeInstr(LCD_INSTR_nextLine);
	LCD_print("Press A-activate");
	
		
	DDRC |= (1 << buzzer);
	
	/*Setare parola*/
	password[0]='0';
	password[1]='0';
	password[2]='0';
	password[3]='0';
	
	while(1){
		
		
		PORTC |= (1 << buzzer);
		PORTC |= (1 << greenLed);
		
		PORTA =0b01111111;
		if (!bit_is_set(PINA, 0)){
			while (!bit_is_set(PINA, 0));
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_print("  ALARM IS ON  ");
			LCD_writeInstr(LCD_INSTR_nextLine);
			detectMove();
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_print("  ALARM IS OFF  ");
			LCD_writeInstr(LCD_INSTR_nextLine);
			LCD_print("Press A-activate");
		}

		/*Daca se apasa buton2 se aprin ledurile rosii*/
		if((PIND & (1<<button2)) == 0) {
			PORTC ^= (1 << redLed);
			_delay_ms(250);	
		}

	}
	return 0;
}